#pragma once

#include "UsageEnvironment.hh"
#include "BasicUsageEnvironment.hh"
#include "GroupsockHelper.hh"
#include "liveMedia.hh"
#include "FrameQueue.h"
#include <string.h>

class Live555Class
{
public:

    Live555Class();
    ~Live555Class();

    void InitializeServer();

    void Start();
    void Stop();

    void SetRTSPPort(int PortNo) {
        RTSPPort = PortNo;
    }

    void SetRTSPUserandPassword(char * Username, char * Password) {
        strcpy(RTSPUser, Username);
        strcpy(RTSPPass, Password);
    }

    void createMediaSession(FrameQueue *m_fqueue);

private:
    int sessionCount;
    int RTSPPort;
    char RTSPUser[128];
    char RTSPPass[128];

    TaskScheduler *scheduler;
    UsageEnvironment *env;
    RTSPServer *rtspServer;
    volatile char watchForStop;

    void SetDefaultValues();
};
