/**********
This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
**********/
// "liveMedia"
// Copyright (c) 1996-2011 Live Networks, Inc.  All rights reserved.
// A template for a MediaSource encapsulating an audio/video input device
//
// NOTE: Sections of this code labeled "%%% TO BE WRITTEN %%%" are incomplete, and needto be written by the programmer
// (depending on the features of the particulardevice).
// C++ header

#ifndef _STREAM_SOURCE_HH
#define _STREAM_SOURCE_HH

#ifndef _FRAMED_SOURCE_HH
#include "FramedSource.hh"
#endif

class FrameQueue;

class StreamSource: public FramedSource
{
    public:
        static StreamSource* createNew(UsageEnvironment& env, FrameQueue *Q_Source);
        static unsigned GetRefCount();

        EventTriggerId getEventID() { return eventTriggerId; }

    protected:
        StreamSource(UsageEnvironment& env, FrameQueue *Q_Source);
        // called only by createNew(), or by subclass constructors
        virtual ~StreamSource();

    private:
        // redefined virtual functions:
        virtual void doGetNextFrame();

    private:
        static void deliverFrame0(void* clientData);
        void deliverFrame();

    private:
        // used to count how many instances of this class currently exist
        // not really used as we are using separate source for each stream
        static unsigned referenceCount;
        FrameQueue *Queue_Source;
        EventTriggerId eventTriggerId;
        struct timeval oldTime;
        bool startCheck;
};

#endif
