#ifndef _UNICAST_MEDIA_SUBSESSION_HH
#define _UNICAST_MEDIA_SUBSESSION_HH

#include <OnDemandServerMediaSubsession.hh>
#include "Live_StreamSource.h"

#include <liveMedia.hh>
#include <string>
#include <list>
#include <iostream>
#include <sstream>


class UnicastMediaSubsession: public OnDemandServerMediaSubsession {

public:
    static UnicastMediaSubsession* createNew(UsageEnvironment& env,
                                             FrameQueue *frmq,
                                             unsigned estimatedBitrate,
	                                         Boolean iFramesOnly = False,
                                             double vshPeriod = 5.0);

protected: // we're a virtual base class
    UnicastMediaSubsession(UsageEnvironment& env,
                           FrameQueue *frmqueue,
                           unsigned estimatedBitrate,
                           Boolean iFramesOnly,
                           double vshPeriod);
    virtual ~UnicastMediaSubsession();

protected:
  unsigned fEstimatedKbps;
  FrameQueue *fFrameQueue;

private:
  Boolean fIFramesOnly;
  // how often (in seconds) to inject a Video_Sequence_Header,
  // if one doesn't already appear in the stream
  double fVSHPeriod;

  // redefined virtual functions
  virtual FramedSource* createNewStreamSource(unsigned clientSessionId,
                                              unsigned& estBitrate);
  virtual RTPSink* createNewRTPSink(Groupsock* rtpGroupsock,
                                    unsigned char rtpPayloadTypeIfDynamic,
                                    FramedSource* inputSource);

};

#endif

